unit AddEdit;

interface

uses
   Windows, SysUtils, Classes, Graphics, Forms, TNTForms, TntStdCtrls, TntButtons,
   Menus, TNTSysUtils, TNTClasses, StrUtils, Math, TntDialogs,
   TntMenus, Buttons, ExtCtrls, StdCtrls, Controls, Dialogs, ShellApi, Messages, ProcessViewer,
   Spin, ActiveX, ComObj, Variants;

function isGUID(const ws: WideString): Boolean;

type
   DriveLetters = record
      Number: ShortInt;
      Letters: array of Char;
   end;
   VMID = record
      Name: WideString;
      ID: AnsiString;
   end;
   CDROMInfo = record
      Letter: AnsiChar;
      Name: AnsiString;
   end;
   TMyObj = class(TObject)
      Text: WideString;
   end;
   TMemoryStatusEx = record
      dwLength: dword;
      dwMemoryLoad: dword;
      ullTotalPhys: int64;
      ullAvailPhys: int64;
      ullTotalPageFile: int64;
      ullAvailPageFile: int64;
      ullTotalVirtual: int64;
      ullAvailVirtual: int64;
      ullAvailExtendedVirtual: int64;
   end;
   TGlobalMemoryStatusEx = function(var mse: TMemoryStatusEx): bool; stdcall;

type
   TfrmAddEdit = class(TTNTForm)
      pnlAll: TPanel;
      edtName: TTntEdit;
      edtExeParams: TTntEdit;
      cmbWS: TTntComboBox;
      cmbPriority: TTntComboBox;
      lblType: TTntLabel;
      lblExeParams: TTntLabel;
      lblFirstDrive: TTntLabel;
      lblName: TTntLabel;
      lblRun: TTntLabel;
      lblSecondDrive: TTntLabel;
      lblVMName: TTntLabel;
      lblPriority: TTntLabel;
      btnOK: TTntBitBtn;
      btnCancel: TTntBitBtn;
      lblVMPath: TTntLabel;
      lblMode: TTntLabel;
      cmbMode: TTntComboBox;
      edtVMPath: TTntEdit;
      btnBrowseForVM: TTntSpeedButton;
      odSearchVM: TTntOpenDialog;
      cmbFirstDrive: TTntComboBox;
      cmbSecondDrive: TTntComboBox;
      cmbVMName: TTntComboBox;
      lblEnableCPUVirtualization: TTntLabel;
      cmbEnableCPUVirtualization: TTntComboBox;
      lblAudio: TTntLabel;
      cmbAudio: TTntComboBox;
      lblMemory: TTntLabel;
      lblHDD: TTntLabel;
      edtHDD: TTntEdit;
      btnBrowseForHDD: TTntSpeedButton;
      odSearchHDD: TTntOpenDialog;
      edtMemory: TSpinEdit;
      lblCDROM: TTntLabel;
      cmbCDROM: TTntComboBox;
      odOpenISO: TTntOpenDialog;
      sbQEMU: TTntSpeedButton;
      sbVirtualBox: TTntSpeedButton;
      pnlType: TPanel;
      procedure sbVirtualBoxClick(Sender: TObject);
      procedure sbQEMUClick(Sender: TObject);
      procedure btnOKClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure cmbModeChange(Sender: TObject);
      procedure btnBrowseForVMClick(Sender: TObject);
      procedure edtExeParamsChange(Sender: TObject);
      procedure cmbDriveChange(Sender: TObject);
      procedure cmbVMNameDropDown(Sender: TObject);
      procedure TntFormCreate(Sender: TObject);
      procedure AllKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure btnBrowseForHDDClick(Sender: TObject);
      procedure edtMemoryKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure cmbCDROMChange(Sender: TObject);
      procedure TntFormActivate(Sender: TObject);
      procedure cmbFirstDriveDrawItem(Control: TWinControl; Index: Integer;
         Rect: TRect; State: TOwnerDrawState);
      procedure cmbSecondDriveDrawItem(Control: TWinControl; Index: Integer;
         Rect: TRect; State: TOwnerDrawState);
    procedure cmbCDROMDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
   private
      { Private declarations }
      meParams: Boolean;
      originaledtHDDWindowProc: TWndMethod;
      originalcmbCDROMWindowProc: TWndMethod;
      originalcmbFirstDriveWindowProc: TWndMethod;
      originalcmbSecondDriveWindowProc: TWndMethod;
      procedure edtHDDWindowProc(var Msg: TMessage);
      procedure cmbCDROMWindowProc(var Msg: TMessage);
      procedure cmbFirstDriveWindowProc(var Msg: TMessage);
      procedure cmbSecondDriveWindowProc(var Msg: TMessage);
      procedure pmChangeMessageBoxW(var Msg: TMessage); message WM_USER + 1024;
   public
      { Public declarations }
      aDL: array of DriveLetters;
      VMIDs: array of VMID;
      aCDROMInfo: array of CDROMInfo;
      ShowedThisSession: Boolean;
      CDDVDType: Byte;
      isEdit: Boolean;
      nCDROMS: Word;
      CBClientWidth: Integer;
      CBMaxLetSize: Integer;
      CBFirstDriveName, CBFirstDriveSize, CBFirstDriveLetters: array of WideString;
      CBSecondDriveName, CBSecondDriveSize, CBSecondDriveLetters: array of WideString;
      procedure GetNamesAndIDs;
      procedure GetCDROMS;
      procedure GetDrives(Sender: TObject);
      function FindCDROMFromLetter(const CDROMLetter: AnsiChar): AnsiString;
   end;

var
   frmAddEdit: TfrmAddEdit;

implementation

uses MainForm, InfoMess;

{$R *.dfm}

procedure TfrmAddEdit.pmChangeMessageBoxW(var Msg: TMessage);
var
   MBRect: TRect;
   i, x, y, w, h: integer;
   ws: WideString;
   p: PAnsiChar;
begin
   GetProcessList;
   i := 0;
   try
      p := MAKEINTRESOURCE(WC_DIALOG);
      ws := WideString('#' + IntToStr(Integer(p)));
   except
      ws := '#32770';
   end;
   while i <= High(ProcessInfo) do
   begin
      if ProcessInfo[i].WClass = ws then
         if ProcessInfo[i].WCaption = msgBoxCaption then
            if GetParent(ProcessInfo[i].Handle) = Handle then
               Break;
      Inc(i);
   end;
   if i <= High(ProcessInfo) then
   begin
      try
         if not GetWindowRect(ProcessInfo[i].Handle, MBRect) then
            Exit;
      except
         Exit;
      end;
      w := MBRect.Right - MBRect.Left;
      h := MBRect.Bottom - MBRect.Top;

      x := Left + ((Width - w) div 2);
      if x < 0 then
         x := 0
      else if x + w > Screen.Width then
         x := Screen.Width - w;
      y := Top + ((Height - h) div 2);
      if y < 0 then
         y := 0
      else if y + h > Screen.Height then
         y := Screen.Height - h;
      try
         SetWindowPos(ProcessInfo[i].Handle, 0, x, y, 0, 0, SWP_NOACTIVATE or SWP_NOSIZE
            or SWP_NOZORDER);
      except
      end;
   end;
end;

function isGUID(const ws: WideString): Boolean;
var
   i, l: Integer;
begin
   Result := False;
   l := Length(ws);
   if l <> 36 then
      Exit;
   for i := 1 to 36 do
      if i in [9, 14, 19, 24] then
      begin
         if ws[i] <> '-' then
            Exit;
      end
      else if ((ws[i] < '0') or (ws[i] > '9')) and ((ws[i] < 'A') or (ws[i] > 'F')) and ((ws[i] < 'a') or (ws[i] > 'f')) then
         Exit;
   Result := True;
end;

procedure TfrmAddEdit.sbVirtualBoxClick(Sender: TObject);
var
   p: Integer;
begin
   sbVirtualBox.Down := True;
   if not sbQEMU.Down then
      Exit;
   sbQEMU.Down := False;
   lblMode.Visible := True;
   cmbMode.Visible := True;
   if not meParams then
   begin
      edtExeParams.Text := '';
      meParams := False;
   end;
   if Visible then
      cmbMode.ItemIndex := 0;
   cmbModeChange(cmbMode);
   p := cmbWS.ItemIndex;
   cmbWS.Items.Text := GetLangTextDef(idxAddEdit, ['Comboboxes', 'WindowSize', 'VirtualBox'], 'Normal'#13#10'Minimized'#13#10'Maximized'#13#10'Fullscreen');
   cmbWS.ItemIndex := p;
   lblAudio.Visible := False;
   cmbAudio.Visible := False;
   lblMemory.Visible := False;
   edtMemory.Visible := False;
   lblHDD.Visible := False;
   edtHDD.Visible := False;
   btnBrowseForHDD.Visible := False;
   lblCDROM.Visible := False;
   cmbCDROM.Visible := False;
   p := -lblType.Top + lblName.Top;
   if ShowVBCPUVirtualizationOption then
   begin
      Height := Height - 2 * p;
      lblEnableCPUVirtualization.Visible := True;
      cmbEnableCPUVirtualization.Visible := True;
      lblFirstDrive.Top := lblFirstDrive.Top + 3 * p;
      cmbFirstDrive.Top := cmbFirstDrive.Top + 3 * p;
      lblExeParams.Top := lblExeParams.Top + 3 * p;
      edtExeParams.Top := edtExeParams.Top + 3 * p;
      lblVMPath.Top := lblVMPath.Top + 3 * p;
      btnBrowseForVM.Top := btnBrowseForVM.Top + 3 * p;
      edtVMPath.Top := edtVMPath.Top + 3 * p;
      lblVMName.Top := lblVMName.Top + 3 * p;
      cmbVMName.Top := cmbVMName.Top + 3 * p;
      if AddSecondDrive then
      begin
         lblSecondDrive.Top := lblSecondDrive.Top + 3 * p;
         cmbSecondDrive.Top := cmbSecondDrive.Top + 3 * p;
      end;
   end
   else
   begin
      Height := Height - 3 * p;
      lblExeParams.Top := lblExeParams.Top + 4 * p;
      edtExeParams.Top := edtExeParams.Top + 4 * p;
      lblVMPath.Top := lblVMPath.Top + 4 * p;
      btnBrowseForVM.Top := btnBrowseForVM.Top + 4 * p;
      edtVMPath.Top := edtVMPath.Top + 4 * p;
      lblVMName.Top := lblVMName.Top + 4 * p;
      cmbVMName.Top := cmbVMName.Top + 4 * p;
      lblFirstDrive.Top := lblFirstDrive.Top + 4 * p;
      cmbFirstDrive.Top := cmbFirstDrive.Top + 4 * p;
      if AddSecondDrive then
      begin
         lblSecondDrive.Top := lblSecondDrive.Top + 4 * p;
         cmbSecondDrive.Top := cmbSecondDrive.Top + 4 * p;
      end;
   end;
   if Visible then
      edtName.SetFocus;
end;

procedure TfrmAddEdit.sbQEMUClick(Sender: TObject);
var
   i, j, p, l: Integer;
   ws, r: WideString;
begin
   sbQEMU.Down := True;
   if not sbVirtualBox.Down then
      Exit;
   sbVirtualBox.Down := False;
   if Visible then
      SendMessage(Handle, WM_SETREDRAW, WPARAM(False), 0);
   lblMode.Visible := False;
   cmbMode.Visible := False;
   if not meParams then
   begin
      ws := QEMUDefaultParameters;
      p := Pos('-m ', ws);
      if (p = 1) or ((p > 1) and (ws[p - 1] = ' ')) then
      begin
         r := '';
         l := Length(ws);
         for i := p + 3 to l do
            if (ws[i] >= '0') and (ws[i] <= '9') then
               r := r + ws[i]
            else
               Break;
         edtMemory.Text := IntToStr(Min(Max(StrToIntDef(r, 512), 0), 65535));
         Delete(ws, Max(1, p - 1), i - Max(1, p - 1));
      end;
      p := Pos('-soundhw ', ws);
      if (p = 1) or ((p > 1) and (ws[p - 1] = ' ')) then
      begin
         r := '';
         l := Length(ws);
         for i := p + 9 to l do
            if (ws[i] <> ' ') and (ws[i] <> '-') then
               r := r + ws[i]
            else
               Break;
         if r = 'sb16' then
            j := 1
         else if r = 'pcspk' then
            j := 2
         else if r = 'hda' then
            j := 3
         else if r = 'gus' then
            j := 4
         else if r = 'es1370' then
            j := 5
         else if r = 'cs4231a' then
            j := 6
         else if r = 'adlib' then
            j := 7
         else if r = 'ac97' then
            j := 8
         else
            j := 0;
         cmbAudio.ItemIndex := j;
         Delete(ws, Max(1, p - 1), i - Max(1, p - 1));
      end;
      edtExeParams.Text := ws;
      meParams := False;
   end;
   cmbMode.ItemIndex := 2;
   cmbModeChange(cmbMode);
   p := cmbWS.ItemIndex;
   cmbWS.Items.Text := GetLangTextDef(idxAddEdit, ['Comboboxes', 'WindowSize', 'QEMU'], 'Normal'#13#10'Minimized'#13#10'Maximized'#13#10'Hidden');
   cmbWS.ItemIndex := p;
   lblMemory.Visible := True;
   edtMemory.Visible := True;
   lblAudio.Visible := True;
   cmbAudio.Visible := True;
   lblHDD.Visible := True;
   edtHDD.Visible := True;
   btnBrowseForHDD.Visible := True;
   lblCDROM.Visible := True;
   cmbCDROM.Visible := True;
   p := -lblType.Top + lblName.Top;
   if ShowVBCPUVirtualizationOption then
   begin
      Height := Height + 2 * p;
      lblEnableCPUVirtualization.Visible := False;
      cmbEnableCPUVirtualization.Visible := False;
      lblExeParams.Top := lblExeParams.Top - 3 * p;
      edtExeParams.Top := edtExeParams.Top - 3 * p;
      lblVMPath.Top := lblVMPath.Top - 3 * p;
      lblVMName.Top := lblVMName.Top - 3 * p;
      btnBrowseForVM.Top := btnBrowseForVM.Top - 3 * p;
      edtVMPath.Top := edtVMPath.Top - 3 * p;
      cmbVMName.Top := cmbVMName.Top - 3 * p;
      lblFirstDrive.Top := lblFirstDrive.Top - 3 * p;
      cmbFirstDrive.Top := cmbFirstDrive.Top - 3 * p;
      if AddSecondDrive then
      begin
         lblSecondDrive.Top := lblSecondDrive.Top - 3 * p;
         cmbSecondDrive.Top := cmbSecondDrive.Top - 3 * p;
      end;
   end
   else
   begin
      Height := Height + 3 * p;
      lblExeParams.Top := lblExeParams.Top - 4 * p;
      edtExeParams.Top := edtExeParams.Top - 4 * p;
      lblVMPath.Top := lblVMPath.Top - 4 * p;
      lblVMName.Top := lblVMName.Top - 4 * p;
      btnBrowseForVM.Top := btnBrowseForVM.Top - 4 * p;
      edtVMPath.Top := edtVMPath.Top - 4 * p;
      cmbVMName.Top := cmbVMName.Top - 4 * p;
      lblFirstDrive.Top := lblFirstDrive.Top - 4 * p;
      cmbFirstDrive.Top := cmbFirstDrive.Top - 4 * p;
      if AddSecondDrive then
      begin
         lblSecondDrive.Top := lblSecondDrive.Top - 4 * p;
         cmbSecondDrive.Top := cmbSecondDrive.Top - 4 * p;
      end;
   end;
   if Visible then
   begin
      if Visible then
         edtName.SetFocus;
      SendMessage(Handle, WM_SETREDRAW, WPARAM(True), 0);
      RedrawWindow(Handle, nil, 0, RDW_ERASE or RDW_FRAME or
         RDW_INVALIDATE or RDW_ALLCHILDREN or RDW_UPDATENOW);
      GetCDROMS;
   end;
end;

function GlobalMemoryStatusEx(var lpBuffer: TMemoryStatusEx): BOOL; stdcall; external kernel32;

procedure TfrmAddEdit.btnOKClick(Sender: TObject);
var
   i, p, l, cp, n1, n2, n3, a1: Integer;
   ws, wst: WideString;
   MemStatEx: TMemoryStatusEx;
begin
   ModalResult := mrNone;
   if Trim(edtName.Text) = '' then
   begin
      msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      MessageBoxW(Handle,
         PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'SetAName'], 'Please set a name !')),
         PWideChar(msgBoxCaption),
         MB_OK or MB_ICONWARNING);
      edtName.SetFocus;
      Exit;
   end;
   if Caption = 'Add' then
   begin
      i := 0;
      ws := WideLowerCase(Trim(edtName.Text));
      while i < Length(VMEntries) do
      begin
         if WideLowerCase(VMEntries[i].Name) = ws then
            Break;
         Inc(i);
      end;
      if i < Length(VMEntries) then
      begin
         msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
         PostMessage(Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'EntryExists'], 'An entry with this name already exists !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
         edtName.SetFocus;
         Exit;
      end;
   end
   else
   begin
      i := 0;
      ws := WideLowerCase(Trim(edtName.Text));
      while i < Length(VMEntries) do
      begin
         if WideLowerCase(VMEntries[i].Name) = ws then
            Break;
         Inc(i);
      end;
      if (i < Length(VMEntries)) and (i <> frmMain.lvVMs.ItemIndex) then
      begin
         msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
         PostMessage(Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'EntryExists'], 'An entry with this name already exists !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
         edtName.SetFocus;
         Exit;
      end;
   end;
   if sbVirtualBox.Down then
   begin
      case cmbMode.ItemIndex of
         1: if Trim(edtVMPath.Text) = '' then
            begin
               msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
               PostMessage(Handle, WM_USER + 1024, 0, 0);
               MessageBoxW(Handle,
                  PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'SetVMPath'], 'Please set the VM Path !')),
                  PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
               edtVMPath.SetFocus;
               Exit;
            end
            else
            begin
               ws := WideChangeFileExt(WideExtractFileName(Trim(edtVMPath.Text)), '');
               GetNamesAndIDs;
               i := 0;
               while i <= High(VMIDs) do
               begin
                  if VMIDs[i].Name = ws then
                     Break;
                  Inc(i);
               end;
               if i > High(VMIDs) then
               begin
                  msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                  PostMessage(Handle, WM_USER + 1024, 0, 0);
                  MessageBoxW(Handle,
                     PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'VMNotFound'], 'Could not find this VM in the VirtualBox configuration files !'#13#10'Please make sure that VirtualBox is properly installed'#13#10'and the VM is properly registered in the VirtualBox Manager.')),
                     PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                  edtVMPath.SetFocus;
                  Exit;
               end;
            end;
         2: if (Trim(edtExeParams.Text) = '') then
            begin
               msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
               PostMessage(Handle, WM_USER + 1024, 0, 0);
               MessageBoxW(Handle,
                  PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'SetExeParam'], 'Please set the exe parameters !')),
                  PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
               edtExeParams.SetFocus;
               Exit;
            end
            else
            begin
               ws := Trim(edtExeParams.Text);
               p := Pos('--startvm "', ws);
               l := Length(ws);
               if (p > 0) and ((p + 11) < l) then
               begin
                  cp := PosEx('"', ws, p + 11);
                  if cp > 0 then
                     ws := Trim(Copy(ws, p + 11, cp - p - 11))
                  else
                     ws := '';
               end
               else
                  ws := '';
               if WideFileExists(ws) then
               begin
                  wst := WideChangeFileExt(WideExtractFileName(wst), '');
                  GetNamesAndIDs;
                  i := 0;
                  while i <= High(VMIDs) do
                  begin
                     if VMIDs[i].Name = wst then
                        Break;
                     Inc(i);
                  end;
                  if i > High(VMIDs) then
                     ws := '';
               end
               else
               begin
                  with frmMain.xmlGen do
                  begin
                     if Tag = 1 then
                        try
                           Active := True;
                           n1 := ChildNodes.IndexOf('VirtualBox');
                           if n1 > -1 then
                           begin
                              n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                              if n2 > -1 then
                              begin
                                 n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                                 if n3 > -1 then
                                 begin
                                    a1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                                    if a1 > -1 then
                                    begin
                                       wst := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a1].Text;
                                       Replacebks(wst, Length(wst));
                                    end;
                                 end;
                              end;
                           end;
                        except
                        end;
                     Active := False;
                  end;

                  if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) <> '') and WideFileExists(wst + '\' + WideChangeFileExt(ws, '') + '\' + ws) then
                  else if (WideExtractFileName(ws) = ws) and (WideExtractFileExt(ws) = '') and WideFileExists(wst + '\' + ws + '\' + ws + '.vbox') then
                  else if isGUID(ws) then
                  begin
                     i := 0;
                     while i <= High(VMIDs) do
                     begin
                        if VMIDs[i].ID = ws then
                           Break;
                        Inc(i);
                     end;
                     if i > High(VMIDs) then
                        ws := '';
                  end
                  else
                     ws := '';
               end;
               if ws = '' then
               begin
                  msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                  PostMessage(Handle, WM_USER + 1024, 0, 0);
                  MessageBoxW(Handle,
                     PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'SetExeParamCor'], 'Please set the exe parameters correctly !'#13#10'Just use <<--startvm "Path_to_VM or GUID">> (without the <<>>)')),
                     PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                  edtExeParams.SetFocus;
                  Exit;
               end;
            end
         else if cmbVMName.ItemIndex = 0 then
         begin
            if cmbVMName.Items.Count > 1 then
            begin
               msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
               PostMessage(Handle, WM_USER + 1024, 0, 0);
               MessageBoxW(Handle,
                  PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'SetVMName'], 'Please set a VM name !')),
                  PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
               cmbVMName.SetFocus;
               Exit;
            end
            else
            begin
               msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
               PostMessage(Handle, WM_USER + 1024, 0, 0);
               MessageBoxW(Handle,
                  PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NoVMsFound'], 'Please add a VM in VirtualBox Manager or solve the problem'#13#10'with VirtualBox installation so you can set a VM name !')),
                  PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
               cmbVMName.SetFocus;
               Exit;
            end;
         end;
      end;
   end
   else if Trim(edtExeParams.Text) = '' then
   begin
      msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      MessageBoxW(Handle,
         PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'SetExeParam'], 'Please set the exe parameters !')),
         PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
      edtExeParams.SetFocus;
      Exit;
   end;
   if cmbFirstDrive.ItemIndex < 1 then
   begin
      msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
      PostMessage(Handle, WM_USER + 1024, 0, 0);
      if AddSecondDrive then
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'ChooseFirstDrive'], 'Please choose the first drive !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING)
      else
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'ChooseDrive'], 'Please choose the drive !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
      cmbFirstDrive.SetFocus;
      Exit;
   end;
   if AddSecondDrive then
      if cmbFirstDrive.Items[cmbFirstDrive.ItemIndex] = cmbSecondDrive.Items[cmbSecondDrive.ItemIndex] then
      begin
         msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
         PostMessage(Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'DifSecDrive'], 'Please set a different second drive !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
         cmbSecondDrive.SetFocus;
         Exit;
      end;
   if sbQEMU.Down then
   begin
      i := StrToIntDef(edtMemory.Text, -1);
      if (i < 1) or (i > 65535) then
      begin
         msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
         PostMessage(Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'MemoryRange'], 'Please set a memory value in the 1..65535 interval !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
         edtMemory.SetFocus;
         Exit;
      end;
      FillChar(MemStatEx, SizeOf(MemStatEx), 0);
      try
         MemStatEx.dwLength := sizeOf(MemStatEx);
         GlobalMemoryStatusEx(MemStatEx);
      except
         i := 0;
      end;
      if MemStatEx.ullTotalPhys >= 134217728 then
         if i > Round(0.5 * MemStatEx.ullTotalPhys / 1048576) then
         begin
            msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            if MessageBoxW(Handle,
               PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'MoreThanHalfRam'], [i, Round(1.0 * MemStatEx.ullTotalPhys / 1048576)], 'You have assigned more than 50%% of the'#13#10'total physical RAM size (%d from %d MB) !'#13#10#13#10'Are you sure that''s wise...?')),
               PWideChar(msgBoxCaption), MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
            begin
               edtMemory.SetFocus;
               Exit;
            end;
         end;

      if Trim(edtHDD.Text) <> '' then
         if (not WideFileExists(Trim(edtHDD.Text))) and ((Pos('-L .', edtExeParams.Text) > 0) and (not WideFileExists(WideExtractFilePath(ExeQPath) + Trim(edtHDD.Text)))) then
         begin
            msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
            PostMessage(Handle, WM_USER + 1024, 0, 0);
            if MessageBoxW(Handle,
               PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'HDDNotFound'], [Trim(edtHDD.Text)], '"%s" doesn''t seem to exist !'#13#10'Are you sure you want to use it...?'#13#10'Tip: if you don''t want to set an internal HDD, just clear the edit box...')),
               PWideChar(msgBoxCaption), MB_YESNO or MB_ICONWARNING or MB_DEFBUTTON2) <> mrYes then
            begin
               edtHDD.SetFocus;
               Exit;
            end;
         end;
   end;
   ModalResult := mrOK;
end;

procedure TfrmAddEdit.FormShow(Sender: TObject);
begin
   edtName.SetFocus;
   edtName.SelectAll;
end;

procedure TfrmAddEdit.cmbModeChange(Sender: TObject);
begin
   case cmbMode.ItemIndex of
      1:
         begin
            lblVMName.Visible := False;
            cmbVMName.Visible := False;
            lblVMPath.Visible := True;
            edtVMPath.Visible := True;
            btnBrowseForVM.Visible := True;
            lblExeParams.Visible := False;
            edtExeParams.Visible := False;
            if Visible then
            begin
               edtVMPath.SetFocus;
               edtVMPath.SelStart := Length(edtVMPath.Text);
               edtVMPath.SelLength := 0;
            end;
         end;
      2:
         begin
            lblVMName.Visible := False;
            cmbVMName.Visible := False;
            lblVMPath.Visible := False;
            edtVMPath.Visible := False;
            btnBrowseForVM.Visible := False;
            lblExeParams.Visible := True;
            edtExeParams.Visible := True;
            if Visible then
            begin
               edtExeParams.SetFocus;
               edtExeParams.SelStart := Length(edtExeParams.Text);
               edtExeParams.SelLength := 0;
            end;
         end;
   else
      begin
         lblVMName.Visible := True;
         cmbVMName.Visible := True;
         lblVMPath.Visible := False;
         edtVMPath.Visible := False;
         btnBrowseForVM.Visible := False;
         lblExeParams.Visible := False;
         edtExeParams.Visible := False;
         if Visible then
            cmbVMName.SetFocus;
      end;
   end;
end;

procedure TfrmAddEdit.btnBrowseForVMClick(Sender: TObject);
var
   FolderName: WideString;
   n1, n2, n3, a, i, l: Integer;
begin
   FolderName := WideExtractFilePath(odSearchVM.FileName);
   odSearchVM.FileName := '';
   if FolderName = '' then
   begin
      if odSearchVM.InitialDir = '' then
      begin

         with frmMain.xmlGen do
         begin
            if Tag = 1 then
               try
                  Active := True;
                  n1 := ChildNodes.IndexOf('VirtualBox');
                  if n1 > -1 then
                  begin
                     n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
                     if n2 > -1 then
                     begin
                        n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('SystemProperties');
                        if n3 > -1 then
                        begin
                           a := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes.IndexOf('defaultMachineFolder');
                           if a > -1 then
                           begin
                              FolderName := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].AttributeNodes[a].Text;
                              l := Length(FolderName);
                              if l > 2 then
                              begin
                                 i := 1;
                                 while i <= l do
                                 begin
                                    if FolderName[i] = '/' then
                                       FolderName[i] := '\';
                                    Inc(i);
                                 end;
                              end;
                           end;
                        end;
                     end;
                  end;
               except
               end;
            Active := False;
         end;

         if WideDirectoryExists(FolderName) then
            odSearchVM.InitialDir := FolderName;
      end;
   end
   else
      odSearchVM.InitialDir := FolderName;

   if odSearchVM.Execute then
   begin
      edtVMPath.Text := odSearchVM.FileName;
      edtVMPath.SetFocus;
      edtVMPath.SelStart := Length(edtVMPath.Text);
      edtVMPath.SelLength := 0;
   end;
end;

procedure TfrmAddEdit.edtExeParamsChange(Sender: TObject);
begin
   meParams := True;
end;

procedure TfrmAddEdit.cmbDriveChange(Sender: TObject);
begin
   try
      if not sbQEMU.Down then
         if (Sender as TTntComboBox).ItemIndex > 0 then
            if (not DriveMessageShowed) and (not ShowedThisSession) then
            begin
               try
                  if frmInfoMess = nil then
                     Application.CreateForm(TfrmInfoMess, frmInfoMess);
                  with frmInfoMess do
                  begin
                     Caption := GetLangTextDef(idxInfoMess, ['Caption'], 'Information');
                     btnOK.Caption := GetLangTextDef(idxInfoMess, ['OKButton'], 'OK');
                     lblMess.Caption := GetLangTextFormatDef(idxAddEdit, ['Messages', 'AddFirstPort'], [btnOK.Caption], 'It will add the drive to the first available port in the VirtualBox VM''s storage controller(s).'#13#10'If it will not find one available it will fail...'#13#10#13#10 +
                        'If you want to boot from this drive make sure the available port'#13#10'is prior to other ports with HDDs and the VirtualBox VM is set to boot from HDD.');
                     cbNoConfirm.Caption := GetLangTextDef(idxInfoMess, ['DontShow'], 'Don''t show this next time');
                     cbNoConfirm.Checked := True;
                     ShowModal;
                     DriveMessageShowed := cbNoConfirm.Checked;
                  end;
                  ShowedThisSession := True;
               except
               end;
               try
                  if frmInfoMess <> nil then
                  begin
                     frmInfoMess.Free;
                     frmInfoMess := nil;
                  end;
               except
               end;
            end;
   except
   end;
end;

procedure TfrmAddEdit.GetNamesAndIDs;
var
   i, p1, l, n1, n2, n3: Integer;
   wn, wid: WideString;
begin
   SetLength(VMIDs, 0);
   with frmMain.xmlGen do
   begin
      if Tag = 1 then
         try
            Active := True;
            n1 := ChildNodes.IndexOf('VirtualBox');
            if n1 > -1 then
            begin
               n2 := ChildNodes[n1].ChildNodes.IndexOf('Global');
               if n2 > -1 then
               begin
                  n3 := ChildNodes[n1].ChildNodes[n2].ChildNodes.IndexOf('MachineRegistry');
                  if n3 > -1 then
                     for i := 0 to ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes.Count - 1 do
                        try
                           p1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('src');
                           if p1 = -1 then
                              Continue;
                           wn := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[p1].Text;
                           l := Length(wn);
                           if l < 9 then
                              Continue;
                           p1 := l;
                           while p1 > 0 do
                           begin
                              if (wn[p1] = '\') or (wn[p1] = '/') then
                                 Break;
                              Dec(p1);
                           end;
                           wn := WideChangeFileExt(Copy(wn, p1 + 1, l - p1), '');
                           p1 := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes.IndexOf('uuid');
                           if p1 = -1 then
                              Continue;
                           wid := ChildNodes[n1].ChildNodes[n2].ChildNodes[n3].ChildNodes[i].AttributeNodes[p1].Text;
                           l := Length(wid);
                           if l < 3 then
                              Continue;
                           SetLength(VMIDs, Length(VMIDs) + 1);
                           VMIDs[High(VMIDs)].Name := wn;
                           VMIDs[High(VMIDs)].ID := Copy(wid, 2, l - 2);
                        except
                        end;
               end;
            end;
         except
         end;
      Active := False;
   end;
end;

procedure TfrmAddEdit.cmbVMNameDropDown(Sender: TObject);
var
   i: Integer;
   t: TTNTStrings;
begin
   GetNamesAndIDs;
   try
      t := TTntStringList.Create;
      t.Add(GetLangTextDef(idxAddEdit, ['Comboboxes', 'NoneText'], 'None'));
      for i := 0 to High(VMIDs) do
         t.Add('"' + VMIDs[i].Name + '"');
      if not cmbVMName.Items.Equals(t) then
      begin
         i := cmbVMName.ItemIndex;
         cmbVMName.Items.Assign(t);
         cmbVMName.ItemIndex := Min(cmbVMName.Items.Count - 1, i);
      end;
      t.Free;
   except
   end;
end;

procedure TfrmAddEdit.GetDrives(Sender: TObject);
var
   i, j, k: Integer;
   sz: Double;
   hVolume, hDrive: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   ErrorMode: Word;
   ws, wsAdd, vap, size: WideString;
   csz, mu: AnsiString;
   tsl: TTNTStrings;
   Switched: Boolean;

   procedure Round3;
   var
      k, n: Integer;
   begin
      k := 0;
      if sz < 100 then
      begin
         while sz < 1000 do
         begin
            sz := sz * 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz / 10));
         if k <= 2 then
            Insert('.', csz, 4 - k)
         else
         begin
            for n := 1 to k - 2 do
               csz := '0' + csz;
            Insert('.', csz, 2);
         end;
      end
      else if sz > 1000 then
      begin
         while sz > 100 do
         begin
            sz := sz / 10;
            Inc(k);
         end;
         Dec(k);
         csz := IntToStr(Round(sz * 10));
         for n := 1 to k do
            csz := csz + '0';
      end
      else
         csz := IntToStr(Round(sz));
   end;

begin
   if DriveToAdd > -1 then
   begin
      try
         hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(DriveToAdd)), GENERIC_READ,
            FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
      except
         hDrive := INVALID_HANDLE_VALUE;
      end;
      if hDrive = INVALID_HANDLE_VALUE then
         DriveToAdd := -1
      else
      begin
         vap := GetDriveVendorAndProductID(hDrive);
         if vap = '' then
         begin
            DriveToAdd := -1;
            try
               CloseHandle(hDrive);
            except
            end;
         end
         else
         begin
            sz := GetDriveSize(hDrive) / 1073741824;
            try
               CloseHandle(hDrive);
            except
            end;
            if sz <= 0 then
            begin
               DriveToAdd := -1;
               msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
               PostMessage(Handle, WM_USER + 1024, 0, 0);
               MessageBoxW(Handle,
                  PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'CantReadDrive'], [WideSysErrorMessage(LastError)], 'Can''t read from drive !'#13#10#13#10'System message: %s')),
                  PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
            end
            else
            begin
               if sz < 1 then
               begin
                  sz := sz * 1024;
                  mu := ' MB';
               end
               else if sz > 1000 then
               begin
                  sz := sz / 1024;
                  mu := ' TB';
               end
               else
                  mu := ' GB';
               Round3;
               size := csz + mu;
               if size = '' then
                  DriveToAdd := -1;
               wsAdd := vap + ', ' + csz + mu;

               if (Sender = nil) or ((Sender as TTntComboBox).Name = 'cmbFirstDrive') then
               begin
                  SetLength(CBFirstDriveName, cmbFirstDrive.Items.Count);
                  SetLength(CBFirstDriveSize, cmbFirstDrive.Items.Count);
                  SetLength(CBFirstDriveLetters, cmbFirstDrive.Items.Count);
                  CBFirstDriveName[High(CBFirstDriveName)] := vap;
                  CBFirstDriveSize[High(CBFirstDriveSize)] := size;
                  CBFirstDriveLetters[High(CBFirstDriveLetters)] := '[ ]';
                  CBMaxLetSize := cmbFirstDrive.Canvas.TextWidth('  [ ]');
                  cmbFirstDrive.Items.Append(wsAdd + ' ]');
                  cmbFirstDrive.ItemIndex := cmbFirstDrive.Items.Count - 1;
                  cmbFirstDrive.Invalidate;
               end;
               if AddSecondDrive and ((Sender = nil) or ((Sender as TTntComboBox).Name = 'cmbSecondDrive')) then
               begin
                  SetLength(CBSecondDriveName, cmbSecondDrive.Items.Count);
                  SetLength(CBSecondDriveSize, cmbSecondDrive.Items.Count);
                  SetLength(CBSecondDriveLetters, cmbSecondDrive.Items.Count);
                  CBSecondDriveName[High(CBSecondDriveName)] := vap;
                  CBSecondDriveSize[High(CBSecondDriveSize)] := size;
                  CBSecondDriveLetters[High(CBSecondDriveLetters)] := '[ ]';
                  CBMaxLetSize := cmbSecondDrive.Canvas.TextWidth('  [ ]');
                  cmbSecondDrive.Items.Append(wsAdd + ' ]');
                  cmbSecondDrive.ItemIndex := cmbSecondDrive.Items.Count - 1;
                  cmbSecondDrive.Invalidate;
               end;
            end;
         end;
      end;
   end;

   tsl := TTntStringList.Create;
   tsl.BeginUpdate;
   tsl.Add(GetLangTextDef(idxAddEdit, ['Comboboxes', 'NoneText'], 'None'));
   ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
   SetLength(aDL, 1);
   aDl[0].Number := -1;
   for i := Byte('C') to Byte('Z') do
   begin
      try
         case GetDriveType(PAnsiChar(AnsiChar(i) + ':\')) of
            DRIVE_REMOVABLE, DRIVE_FIXED:
               begin
                  try
                     hVolume := CreateFile(PAnsiChar('\\.\' + Char(i) + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                  except
                     hVolume := INVALID_HANDLE_VALUE;
                  end;
                  if hVolume <> INVALID_HANDLE_VALUE then
                  begin
                     if ListOnlyUSBDrives and (not IsUSBDrive(hVolume)) then
                     begin
                        try
                           CloseHandle(hVolume);
                        except
                        end;
                        Continue;
                     end;
                     dwBytesReturned := 0;
                     try
                        if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                           if sdn.DeviceNumber <> OSDrive then
                           begin
                              j := 0;
                              while j <= High(aDL) do
                              begin
                                 if Cardinal(aDL[j].Number) = sdn.DeviceNumber then
                                    Break;
                                 Inc(j);
                              end;
                              if j > High(aDL) then
                              begin
                                 SetLength(adl, Length(adl) + 1);
                                 aDL[j].Number := sdn.DeviceNumber;
                              end;
                              SetLength(aDL[j].Letters, Length(aDL[j].Letters) + 1);
                              aDL[j].Letters[High(aDL[j].Letters)] := Char(i);
                           end;
                     except
                     end;
                     try
                        CloseHandle(hVolume);
                     except
                     end;
                  end;
               end
         else
            Continue;
         end;
      except
      end;
   end;
   for i := 0 to MAX_IDE_DRIVES - 1 do
   begin
      if i = OSDrive then
         Continue;
      j := 0;
      while j <= High(aDL) do
      begin
         if aDL[j].Number = i then
            Break;
         Inc(j);
      end;
      if j > High(aDL) then
      begin
         try
            hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(i)), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
         except
            hDrive := INVALID_HANDLE_VALUE;
         end;
         if hDrive <> INVALID_HANDLE_VALUE then
         begin
            if ListOnlyUSBDrives and (not IsUSBDrive(hDrive)) then
            begin
               try
                  CloseHandle(hDrive);
               except
               end;
               Continue;
            end;
            try
               CloseHandle(hDrive);
            except
            end;
            SetLength(aDL, Length(aDL) + 1);
            aDL[High(aDL)].Number := i;
         end;
      end;
   end;
   if Length(aDl) > 2 then
   begin
      repeat
         Switched := False;
         for i := 1 to High(aDL) - 1 do
            if aDL[i].Number > aDL[i + 1].Number then
            begin
               csz := AnsiString(aDL[i].Letters);
               aDL[i].Letters := aDL[i + 1].Letters;
               SetLength(aDL[i + 1].Letters, Length(csz));
               Move(csz[1], aDL[i + 1].Letters[0], Length(csz));
               j := aDL[i].Number;
               aDL[i].Number := aDL[i + 1].Number;
               aDL[i + 1].Number := j;
               Switched := True;
            end;
      until not Switched;
   end;
   if (Sender = nil) or ((Sender as TTntComboBox).Name = 'cmbFirstDrive') then
   begin
      SetLength(CBFirstDriveName, 0);
      SetLength(CBFirstDriveSize, 0);
      SetLength(CBFirstDriveLetters, 0);
      CBMaxLetSize := 0;

      if Length(aDl) > 1 then
      begin
         SetLength(CBFirstDriveName, Length(aDL) - 1);
         SetLength(CBFirstDriveSize, Length(aDL) - 1);
         SetLength(CBFirstDriveLetters, Length(aDL) - 1);
         j := 0;
         for i := 1 to High(aDL) do
         begin
            if i <> DriveToAdd then
            begin
               try
                  hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(aDL[i].Number)), GENERIC_READ,
                     FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
               except
                  hDrive := INVALID_HANDLE_VALUE;
               end;
               if hDrive = INVALID_HANDLE_VALUE then
               begin
                  try
                     CloseHandle(hDrive);
                  except
                  end;
                  aDL[i].Number := -1;
                  SetLength(CBFirstDriveName, Length(CBFirstDriveName) - 1);
                  SetLength(CBFirstDriveSize, Length(CBFirstDriveSize) - 1);
                  SetLength(CBFirstDriveLetters, Length(CBFirstDriveLetters) - 1);
                  Continue;
               end;
               ws := GetDriveVendorAndProductID(hDrive);
               CBFirstDriveName[j] := ws;
               sz := GetDriveSize(hDrive) / 1073741824;
               try
                  CloseHandle(hDrive);
               except
               end;
               if sz <= 0 then
               begin
                  aDL[i].Number := -1;
                  SetLength(CBFirstDriveName, Length(CBFirstDriveName) - 1);
                  SetLength(CBFirstDriveSize, Length(CBFirstDriveSize) - 1);
                  SetLength(CBFirstDriveLetters, Length(CBFirstDriveLetters) - 1);
                  Continue;
               end
               else
               begin
                  if sz < 1 then
                  begin
                     sz := sz * 1024;
                     mu := ' MB';
                  end
                  else if sz > 1000 then
                  begin
                     sz := sz / 1024;
                     mu := ' TB';
                  end
                  else
                     mu := ' GB';
                  Round3;
                  ws := ws + ', ' + csz + mu;
                  CBFirstDriveSize[j] := csz + mu;
               end;
               ws := ws + ',  [';
            end
            else
            begin
               ws := wsAdd;
               CBFirstDriveName[j] := vap;
               CBFirstDriveSize[j] := size;
            end;
            CBFirstDriveLetters[j] := '[';
            if Length(aDl[i].Letters) > 0 then
            begin
               k := 0;
               while k < High(aDl[i].Letters) do
               begin
                  ws := ws + aDl[i].Letters[k] + ', ';
                  CBFirstDriveLetters[j] := CBFirstDriveLetters[j] + aDl[i].Letters[k] + ', ';
                  Inc(k);
               end;
               ws := ws + aDl[i].Letters[k];
               CBFirstDriveLetters[j] := CBFirstDriveLetters[j] + aDl[i].Letters[k];
            end;
            ws := ws + ']';
            CBFirstDriveLetters[j] := CBFirstDriveLetters[j] + ']';
            CBMaxLetSize := Max(CBMaxLetSize, cmbFirstDrive.Canvas.TextWidth(CBFirstDriveLetters[j] + '  '));
            tsl.Add(ws);
            Inc(j);
         end;
      end;
   end;
   if AddSecondDrive and ((Sender = nil) or ((Sender as TTntComboBox).Name = 'cmbSecondDrive')) then
   begin
      if Sender = nil then
      begin
         SetLength(CBSecondDriveName, Length(CBFirstDriveName));
         SetLength(CBSecondDriveSize, Length(CBFirstDriveName));
         SetLength(CBSecondDriveLetters, Length(CBFirstDriveName));
         for i := 0 to High(CBFirstDriveName) do
         begin
            CBSecondDriveName[i] := CBFirstDriveName[i];
            CBSecondDriveSize[i] := CBFirstDriveSize[i];
            CBSecondDriveLetters[i] := CBFirstDriveLetters[i];
         end;
      end
      else
      begin
         SetLength(CBSecondDriveName, 0);
         SetLength(CBSecondDriveSize, 0);
         SetLength(CBSecondDriveLetters, 0);
         CBMaxLetSize := 0;

         if Length(aDl) > 1 then
         begin
            SetLength(CBSecondDriveName, Length(aDL) - 1);
            SetLength(CBSecondDriveSize, Length(aDL) - 1);
            SetLength(CBSecondDriveLetters, Length(aDL) - 1);
            j := 0;
            for i := 1 to High(aDL) do
            begin
               if i <> DriveToAdd then
               begin
                  try
                     hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(aDL[i].Number)), GENERIC_READ,
                        FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                  except
                     hDrive := INVALID_HANDLE_VALUE;
                  end;
                  if hDrive = INVALID_HANDLE_VALUE then
                  begin
                     try
                        CloseHandle(hDrive);
                     except
                     end;
                     aDL[i].Number := -1;
                     SetLength(CBSecondDriveName, Length(CBSecondDriveName) - 1);
                     SetLength(CBSecondDriveSize, Length(CBSecondDriveSize) - 1);
                     SetLength(CBSecondDriveLetters, Length(CBSecondDriveLetters) - 1);
                     Continue;
                  end;
                  ws := GetDriveVendorAndProductID(hDrive);
                  CBSecondDriveName[j] := ws;
                  sz := GetDriveSize(hDrive) / 1073741824;
                  try
                     CloseHandle(hDrive);
                  except
                  end;
                  if sz <= 0 then
                  begin
                     aDL[i].Number := -1;
                     SetLength(CBSecondDriveName, Length(CBSecondDriveName) - 1);
                     SetLength(CBSecondDriveSize, Length(CBSecondDriveSize) - 1);
                     SetLength(CBSecondDriveLetters, Length(CBSecondDriveLetters) - 1);
                     Continue;
                  end
                  else
                  begin
                     if sz < 1 then
                     begin
                        sz := sz * 1024;
                        mu := ' MB';
                     end
                     else if sz > 1000 then
                     begin
                        sz := sz / 1024;
                        mu := ' TB';
                     end
                     else
                        mu := ' GB';
                     Round3;
                     ws := ws + ', ' + csz + mu;
                     CBSecondDriveSize[j] := csz + mu;
                  end;
                  ws := ws + ',  [';
               end
               else
               begin
                  ws := wsAdd;
                  CBSecondDriveName[j] := vap;
                  CBSecondDriveSize[j] := size;
               end;
               CBSecondDriveLetters[j] := '[';
               if Length(aDl[i].Letters) > 0 then
               begin
                  k := 0;
                  while k < High(aDl[i].Letters) do
                  begin
                     ws := ws + aDl[i].Letters[k] + ', ';
                     CBSecondDriveLetters[j] := CBSecondDriveLetters[j] + aDl[i].Letters[k] + ', ';
                     Inc(k);
                  end;
                  ws := ws + aDl[i].Letters[k];
                  CBSecondDriveLetters[j] := CBSecondDriveLetters[j] + aDl[i].Letters[k];
               end;
               ws := ws + ']';
               CBSecondDriveLetters[j] := CBSecondDriveLetters[j] + ']';
               CBMaxLetSize := Max(CBMaxLetSize, cmbSecondDrive.Canvas.TextWidth(CBSecondDriveLetters[j] + '  '));
               tsl.Add(ws);
               Inc(j);
            end;
         end;
      end;
   end;
   SetErrorMode(ErrorMode);
   try
      if DriveToAdd > -1 then
      begin
         i := 1;
         while i < tsl.Count do
         begin
            if Pos(wsAdd, tsl[i]) = 1 then
               Break;
            Inc(i);
         end;
         if i = tsl.Count then
            DriveToAdd := -1
         else
            DriveToAdd := i;
      end;
      if Sender = nil then
      begin
         if not cmbFirstDrive.Items.Equals(tsl) then
            cmbFirstDrive.Items.Assign(tsl);
         if AddSecondDrive then
            if not cmbSecondDrive.Items.Equals(tsl) then
               cmbSecondDrive.Items.Assign(tsl);
         if isEdit then
         begin
            with VMentries[frmMain.lvVMS.ItemIndex] do
            begin
               if FirstDriveName <> '' then
               begin
                  ws := FirstDriveName + ',  [';
                  i := 1;
                  while i < cmbFirstDrive.Items.Count do
                  begin
                     if Pos(ws, cmbFirstDrive.Items[i]) = 1 then
                     begin
                        cmbFirstDrive.ItemIndex := i;
                        Break;
                     end;
                     Inc(i);
                  end;
                  if i = cmbFirstDrive.Items.Count then
                     cmbFirstDrive.ItemIndex := 0;
               end
               else
                  cmbFirstDrive.ItemIndex := 0;
               if AddSecondDrive then
                  if SecondDriveName <> '' then
                  begin
                     ws := SecondDriveName + ',  [';
                     i := 1;
                     while i < cmbSecondDrive.Items.Count do
                     begin
                        if Pos(ws, cmbSecondDrive.Items[i]) = 1 then
                        begin
                           cmbSecondDrive.ItemIndex := i;
                           Break;
                        end;
                        Inc(i);
                     end;
                     if i = cmbSecondDrive.Items.Count then
                        cmbSecondDrive.ItemIndex := 0;
                  end
                  else
                     cmbSecondDrive.ItemIndex := 0;
            end;
         end
         else
         begin
            if DriveToAdd > -1 then
               cmbFirstDrive.ItemIndex := DriveToAdd
            else
               cmbFirstDrive.ItemIndex := 0;
            if AddSecondDrive then
               cmbSecondDrive.ItemIndex := 0;
         end;
      end
      else
      begin
         if not (Sender as TTntComboBox).Items.Equals(tsl) then
         begin
            i := (Sender as TTntComboBox).ItemIndex;
            (Sender as TTntComboBox).Items.Assign(tsl);
            if DriveToAdd = -1 then
               (Sender as TTntComboBox).ItemIndex := Min((Sender as TTntComboBox).Items.Count - 1, i)
            else
               (Sender as TTntComboBox).ItemIndex := Min((Sender as TTntComboBox).Items.Count - 1, DriveToAdd);
         end
         else if DriveToAdd > -1 then
            (Sender as TTntComboBox).ItemIndex := Min((Sender as TTntComboBox).Items.Count - 1, DriveToAdd);
      end;
   except
   end;
   DriveToAdd := -1;
   tsl.Free;
end;

procedure TfrmAddEdit.TntFormCreate(Sender: TObject);
var
   bflenfd, bflensd: Integer;
begin
   bflenfd := lblFirstDrive.Width;
   bflensd := lblSecondDrive.Width;
   lblAudio.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'Audio'], 'Audio');
   lblCDROM.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'CDROM'], 'CD/DVD device:');
   lblEnableCPUVirtualization.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'EnableCPUVirtualization'], 'Enable VT-x/AMD-V:');
   lblExeParams.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'ExeParams'], 'Exe parameters:');
   lblFirstDrive.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'FirstDrive'], 'First drive to add and boot:');
   lblHDD.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'HDD'], 'Internal HDD:');
   lblMemory.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'Memory'], 'Memory (MB):');
   lblMode.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'Mode'], 'Mode to load the VM:');
   lblName.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'Name'], 'Name:');
   lblPriority.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'Priority'], 'CPU priority:');
   lblRun.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'Run'], 'Run:');
   lblSecondDrive.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'SecondDrive'], 'Second drive to add (optional):');
   lblType.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'Type'], 'Type:');
   lblVMName.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'VMName'], 'VM name:');
   lblVMPath.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'VMPath'], 'VM path:');
   odSearchVM.Title := GetLangTextDef(idxAddEdit, ['Dialogs', 'LoadVM', 'Title'], 'Load');
   odSearchVM.Filter := GetLangTextDef(idxAddEdit, ['Dialogs', 'LoadVM', 'Filter'], 'VirtualBox VM (*.vbox)|*.vbox|All files (*.*)|*.*');
   odSearchHDD.Title := GetLangTextDef(idxAddEdit, ['Dialogs', 'LoadHDDImage', 'Title'], 'Load');
   odSearchHDD.Filter := GetLangTextDef(idxAddEdit, ['Dialogs', 'LoadHDDImage', 'Filter'], 'QEMU disk images|*.img;*.qcow;*.qcow2;*.qed;*.qcow;*.cow;*.vdi;*.vmdk;*.vpc|All files|*.*');
   odOpenISO.Title := GetLangTextDef(idxAddEdit, ['Dialogs', 'LoadISO', 'Title'], 'Load');
   odOpenISO.Filter := GetLangTextDef(idxAddEdit, ['Dialogs', 'LoadISO', 'Filter'], 'ISO files|*.iso|All files|*.*');
   btnOK.Caption := GetLangTextDef(idxAddEdit, ['Buttons', 'OK'], 'OK');
   btnCancel.Caption := GetLangTextDef(idxAddEdit, ['Buttons', 'Cancel'], 'Cancel');
   cmbAudio.Items[0] := GetLangTextDef(idxAddEdit, ['Comboboxes', 'NoneText'], 'None');
   cmbAudio.ItemIndex := 1;
   cmbCDROM.Items[0] := GetLangTextDef(idxAddEdit, ['Comboboxes', 'NoneText'], 'None');
   cmbCDROM.ItemIndex := 0;
   cmbFirstDrive.Items[0] := GetLangTextDef(idxAddEdit, ['Comboboxes', 'NoneText'], 'None');
   cmbFirstDrive.ItemIndex := 0;
   cmbVMName.Items[0] := GetLangTextDef(idxAddEdit, ['Comboboxes', 'NoneText'], 'None');
   cmbVMName.ItemIndex := 0;
   cmbSecondDrive.Items[0] := GetLangTextDef(idxAddEdit, ['Comboboxes', 'NoneText'], 'None');
   cmbSecondDrive.ItemIndex := 0;
   cmbEnableCPUVirtualization.Items.Text := GetLangTextDef(idxAddEdit, ['Comboboxes', 'EnableCPUVirtualization'], 'Unchanged'#13#10'On'#13#10'Off'#13#10'Switch');
   cmbEnableCPUVirtualization.ItemIndex := 0;
   cmbMode.Items.Text := GetLangTextDef(idxAddEdit, ['Comboboxes', 'Mode'], 'VM name'#13#10'VM path'#13#10'Exe parameters');
   cmbMode.ItemIndex := 0;
   cmbPriority.Items.Text := GetLangTextDef(idxAddEdit, ['Comboboxes', 'Priority'], 'BelowNormal'#13#10'Normal'#13#10'AboveNormal'#13#10'High');
   cmbPriority.ItemIndex := 1;
   cmbWS.Items.Text := GetLangTextDef(idxAddEdit, ['Comboboxes', 'WindowSize', 'VirtualBox'], 'Normal'#13#10'Minimized'#13#10'Maximized'#13#10'Fullscreen');
   cmbWS.ItemIndex := 0;
   btnBrowseForVM.Hint := GetLangTextDef(idxAddEdit, ['Hints', 'BrowseForVM'], 'click to browse for VM');
   btnBrowseForHDD.Hint := GetLangTextDef(idxAddEdit, ['Hints', 'BrowseForHdd'], 'click to browse for HDD image file');
   bflenfd := lblFirstDrive.Width - bflenfd;
   bflensd := lblSecondDrive.Width - bflensd;
   if not AddSecondDrive then
   begin
      lblSecondDrive.Visible := False;
      cmbSecondDrive.Visible := False;
      lblFirstDrive.Caption := GetLangTextDef(idxAddEdit, ['Labels', 'Drive'], 'Drive to add and boot:');
      lblFirstDrive.Anchors := [akTop];
      cmbFirstDrive.Anchors := [akTop];
      lblVMPath.Anchors := [akTop];
      lblVMName.Anchors := [akTop];
      lblExeParams.Anchors := [akTop];
      cmbVMName.Anchors := [akTop];
      btnBrowseForVM.Anchors := [akTop];
      edtVMPath.Anchors := [akTop];
      edtExeParams.Anchors := [akTop];
      Height := Height + lblType.Top - lblName.Top;
      lblFirstDrive.Anchors := [akLeft, akBottom];
      cmbFirstDrive.Anchors := [akRight, akBottom];
      lblVMPath.Anchors := [akLeft, akBottom];
      lblVMName.Anchors := [akLeft, akBottom];
      lblExeParams.Anchors := [akLeft, akBottom];
      cmbVMName.Anchors := [akRight, akBottom];
      btnBrowseForVM.Anchors := [akRight, akBottom];
      edtVMPath.Anchors := [akRight, akBottom];
      edtExeParams.Anchors := [akRight, akBottom];
      Width := Width + lblFirstDrive.Width - lblSecondDrive.Width + bflenfd;
   end
   else if bflensd <> 0 then
      Width := Width + bflensd;
   if not ShowVBCPUVirtualizationOption then
   begin
      lblEnableCPUVirtualization.Visible := False;
      cmbEnableCPUVirtualization.Visible := False;
      lblVMPath.Top := lblVMPath.Top - lblType.Top + lblName.Top;
      lblVMName.Top := lblVMName.Top - lblType.Top + lblName.Top;
      lblExeParams.Top := lblExeParams.Top - lblType.Top + lblName.Top;
      edtVMPath.Top := edtVMPath.Top - lblType.Top + lblName.Top;
      cmbVMName.Top := cmbVMName.Top - lblType.Top + lblName.Top;
      btnBrowseForVM.Top := btnBrowseForVM.Top - lblType.Top + lblName.Top;
      edtExeParams.Top := edtExeParams.Top - lblType.Top + lblName.Top;
      lblFirstDrive.Top := lblFirstDrive.Top - lblType.Top + lblName.Top;
      cmbFirstDrive.Top := cmbFirstDrive.Top - lblType.Top + lblName.Top;
      if AddSecondDrive then
      begin
         lblSecondDrive.Top := lblSecondDrive.Top - lblType.Top + lblName.Top;
         cmbSecondDrive.Top := cmbSecondDrive.Top - lblType.Top + lblName.Top;
      end;
      Height := Height + lblType.Top - lblName.Top;
   end;
   ShowedThisSession := False;
   originaledtHDDWindowProc := edtHDD.WindowProc;
   edtHDD.WindowProc := edtHDDWindowProc;
   originalcmbCDROMWindowProc := cmbCDROM.WindowProc;
   cmbCDROM.WindowProc := cmbCDROMWindowProc;
   originalcmbFirstDriveWindowProc := cmbFirstDrive.WindowProc;
   cmbFirstDrive.WindowProc := cmbFirstDriveWindowProc;
   originalcmbSecondDriveWindowProc := cmbSecondDrive.WindowProc;
   cmbSecondDrive.WindowProc := cmbSecondDriveWindowProc;
   DragAcceptFiles(edtHDD.Handle, True);
   DragAcceptFiles(cmbCDROM.Handle, True);
   DragAcceptFiles(cmbFirstDrive.Handle, True);
   DragAcceptFiles(cmbSecondDrive.Handle, True);
   CBClientWidth := Width;
end;

procedure TfrmAddEdit.AllKeyDown(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   if (Shift = []) and (Key = VK_F1) then
      frmMain.OpenInternetHelp(Self.Handle, DefSiteHelp);
end;

procedure TfrmAddEdit.btnBrowseForHDDClick(Sender: TObject);
var
   FolderName: WideString;
begin
   if odSearchHDD.FileName <> '' then
   begin
      FolderName := WideExtractFilePath(odSearchHDD.FileName);
      odSearchHDD.FileName := '';
      odSearchHDD.InitialDir := FolderName;
   end;
   if odSearchHDD.Execute then
   begin
      edtHDD.Text := odSearchHDD.FileName;
      edtHDD.SetFocus;
      edtHDD.SelStart := Length(edtHDD.Text);
      edtHDD.SelLength := 0;
   end;
end;

procedure TfrmAddEdit.edtMemoryKeyDown(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   if (Shift = []) then
      case Key of
         VK_RETURN:
            begin
               Key := 0;
               btnOK.Click;
            end;
         VK_F1: frmMain.OpenInternetHelp(Self.Handle, DefSiteHelp);
         VK_ESCAPE:
            begin
               Key := 0;
               btnCancel.Click;
            end;
      end;
end;

procedure TFrmAddEdit.GetCDROMS;
var
   objWMIService: OLEVariant;
   colItems: OLEVariant;
   colItem: OLEVariant;
   oEnum: IEnumvariant;
   iValue: LongWord;
   s: AnsiString;
   i, l: Integer;
   Changed: Boolean;
   tCDROMInfo: CDROMInfo;

   function GetWMIObject(const objectName: AnsiString): IDispatch;
   var
      chEaten: Integer;
      BindCtx: IBindCtx;
      Moniker: IMoniker;
   begin
      OleCheck(CreateBindCtx(0, bindCtx));
      OleCheck(MkParseDisplayName(BindCtx, StringToOleStr(objectName), chEaten, Moniker));
      OleCheck(Moniker.BindToObject(BindCtx, nil, IDispatch, Result));
   end;
begin
   SetLength(aCDROMInfo, 0);
   //CoInitializeEx(nil, COINIT_MULTITHREADED);
   if Succeeded(CoInitialize(nil)) then
      try
         try
            objWMIService := GetWMIObject(Format('winmgmts:\\%s\%s', ['.', 'root\CIMV2']));
            colItems := objWMIService.ExecQuery(Format('SELECT %s FROM %s', ['Drive', 'Win32_CDROMDrive']), 'WQL', 0);
            oEnum := IUnknown(colItems._NewEnum) as IEnumVariant;
            while oEnum.Next(1, colItem, iValue) = 0 do
            begin
               s := colItem.Properties_.Item('Drive', 0);
               SetLength(aCDROMInfo, Length(aCDROMInfo) + 1);
               if (Length(s) = 2) and (s[2] = ':') and (s[1] in ['A'..'Z']) then
                  aCDROMInfo[High(aCDROMInfo)].Letter := s[1]
               else
                  aCDROMInfo[High(aCDROMInfo)].Letter := '0';
            end;
            colItems := objWMIService.ExecQuery(Format('SELECT %s FROM %s', ['Caption', 'Win32_CDROMDrive']), 'WQL', 0);
            oEnum := IUnknown(colItems._NewEnum) as IEnumVariant;
            i := 0;
            while oEnum.Next(1, colItem, iValue) = 0 do
            begin
               if i > High(aCDROMInfo) then
                  Break;
               aCDROMInfo[i].Name := colItem.Properties_.Item('Caption', 0);
               Inc(i);
            end;
         except
         end;
      finally
         CoUninitialize;
      end;
   l := Length(aCDROMInfo);
   if l > 1 then
      repeat
         Changed := False;
         for i := 0 to l - 2 do
            if aCDROMInfo[i].Letter < aCDROMInfo[i + 1].Letter then
            begin
               tCDROMInfo := aCDROMInfo[i];
               aCDROMInfo[i] := aCDROMInfo[i + 1];
               aCDROMInfo[i + 1] := tCDROMInfo;
               Changed := True;
            end;
      until not Changed;
   cmbCDROM.Items.BeginUpdate;
   cmbCDROM.Items.Clear;
   cmbCDROM.Items.Add(GetLangTextDef(idxAddEdit, ['Comboboxes', 'NoneText'], 'None'));
   nCDROMS := 0;
   for i := l - 1 downto 0 do
   begin
      if aCDROMInfo[i].Letter = '0' then
         Break;
      cmbCDROM.Items.Add(aCDROMInfo[i].Name + ',  [' + aCDROMInfo[i].Letter + ']');
      Inc(nCDROMS);
   end;
   cmbCDROM.Items.Add(GetLangTextDef(idxAddEdit, ['Comboboxes', 'LoadISO'], 'Load ISO file...'));
   cmbCDROM.Items.EndUpdate;
   cmbCDROM.ItemIndex := 0;
   cmbCDROM.Tag := 0;
   CDDVDType := 0;
end;

procedure TfrmAddEdit.cmbCDROMChange(Sender: TObject);
var
   ws: WideString;
   Obj: TMyObj;
begin
   if cmbCDROM.ItemIndex = (nCDROMS + 1) then
   begin
      cmbCDROM.OnChange := nil;
      if odOpenISO.FileName <> '' then
      begin
         ws := odOpenISO.FileName;
         odOpenISO.FileName := '';
         odOpenISO.InitialDir := WideExtractFilePath(ws);
      end;
      if odOpenISO.Execute then
      begin
         if cmbCDROM.ItemIndex < (cmbCDROM.Items.Count - 1) then
         begin
            if Assigned(cmbCDROM.Items.Objects[cmbCDROM.Items.Count - 1]) then
               TMyObj(cmbCDROM.Items.Objects[cmbCDROM.Items.Count - 1]).Free();
            cmbCDROM.Items.Delete(cmbCDROM.Items.Count - 1);
         end;
         Obj := TMyObj.Create();
         Obj.Text := odOpenISO.FileName;
         cmbCDROM.Items.AddObject(WideExtractFileName(odOpenISO.FileName), Obj);
         cmbCDROM.ItemIndex := cmbCDROM.Items.Count - 1;
         cmbCDROM.Tag := cmbCDROM.ItemIndex;
         CDDVDType := 1;
      end
      else
         cmbCDROM.ItemIndex := cmbCDROM.Tag;
      cmbCDROM.OnChange := cmbCDROMChange;
   end
   else
   begin
      cmbCDROM.Tag := cmbCDROM.ItemIndex;
      if cmbCDROM.ItemIndex <= nCDROMS then
         CDDVDType := 0;
   end;
end;

procedure TfrmAddEdit.TntFormActivate(Sender: TObject);
var
   i: Integer;
   Obj: TMyObj;
   ws: WideString;
begin
   OnActivate := nil;
   Refresh;
   GetDrives(nil);
   if sbQEMU.Down then
   begin
      GetCDROMS;
      if isEdit then
         with VMentries[frmMain.lvVMS.ItemIndex] do
            if CDROMName <> '' then
               if CDROMType = 0 then
               begin
                  ws := CDROMName + ',  [';
                  i := 1;
                  while i <= nCDROMS do
                  begin
                     if Pos(ws, cmbCDROM.Items[i]) = 1 then
                     begin
                        cmbCDROM.ItemIndex := i;
                        cmbCDROM.Tag := i;
                        Break;
                     end;
                     Inc(i);
                  end;
               end
               else
               begin
                  Obj := TMyObj.Create();
                  Obj.Text := CDROMName;
                  cmbCDROM.Items.AddObject(WideExtractFileName(CDROMName), Obj);
                  cmbCDROM.ItemIndex := cmbCDROM.Items.Count - 1;
                  cmbCDROM.Tag := cmbCDROM.ItemIndex;
                  CDDVDType := 1;
                  ws := WideExtractFilePath(CDROMName);
                  if WideDirectoryExists(ws) then
                     odOpenISO.InitialDir := ws;
               end;
   end;
end;

procedure TfrmAddEdit.edtHDDWindowProc(var Msg: TMessage);
var
   Buffer: array[0..MAX_PATH] of WideChar;
   wstrTemp: WideString;
begin
   if Msg.Msg = WM_DROPFILES then
   begin
      Application.BringToFront;
      frmMain.Repaint;
      Repaint;
      case DragQueryFileW(msg.WParam, $FFFFFFFF, nil, 0) of
         1:
            begin
               DragQueryFileW(msg.WParam, 0, @Buffer, SizeOf(Buffer));
               DragFinish(Msg.WParam);
               wstrTemp := WideString(Buffer);
               if WideFileExists(wstrTemp) then
               begin
                  odSearchHDD.FileName := wstrTemp;
                  edtHDD.Text := wstrTemp;
                  edtHDD.SetFocus;
                  edtHDD.SelStart := Length(edtHDD.Text);
                  edtHDD.SelLength := 0;
               end
               else
               begin
                  msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                  PostMessage(Handle, WM_USER + 1024, 0, 0);
                  MessageBoxW(Handle,
                     PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotAFile'], 'This is not a file !')),
                     PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
               end;
            end;
      else
         DragFinish(msg.WParam);
         msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
         PostMessage(Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'JustOneItem'], 'Just one item at a time !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
      end;
   end
   else
      originaledtHDDWindowProc(Msg);
end;

procedure TfrmAddEdit.cmbCDROMWindowProc(var Msg: TMessage);
var
   Buffer: array[0..MAX_PATH] of WideChar;
   wstrTemp: WideString;
   ErrorMode: Word;
   p: Integer;
   Obj: TMyObj;
begin
   if Msg.Msg = WM_DROPFILES then
   begin
      Application.BringToFront;
      frmMain.Repaint;
      Repaint;
      case DragQueryFileW(msg.WParam, $FFFFFFFF, nil, 0) of
         1:
            begin
               DragQueryFilew(msg.WParam, 0, @Buffer, SizeOf(Buffer));
               DragFinish(msg.WParam);
               wstrTemp := WideString(Buffer);
               if (Length(wstrTemp) = 3) and ((wstrTemp[1] >= 'A') and (wstrTemp[1] <= 'Z')) and (wstrTemp[2] = ':') and
                  (wstrTemp[3] = '\') then
               begin
                  ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
                  try
                     case GetDriveTypeW(PWideChar(wstrTemp)) of
                        DRIVE_CDROM:
                           begin
                              p := cmbCDROM.Items.IndexOf(WideString(FindCDROMFromLetter(AnsiChar(wstrTemp[1]))) + ',  [' + wstrTemp[1] + ']');
                              if (p > -1) and (p <= nCDROMS) then
                              begin
                                 cmbCDROM.ItemIndex := p;
                                 cmbCDROM.SetFocus;
                              end;
                           end
                     else
                        msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                        PostMessage(Handle, WM_USER + 1024, 0, 0);
                        MessageBoxW(Handle,
                           PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotACD'], 'This is not a CD/DVD device !')),
                           PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                        Exit;
                     end;
                  finally
                     SetErrorMode(ErrorMode);
                  end;
               end
               else if WideFileExists(wstrTemp) then
               begin
                  cmbCDROM.OnChange := nil;
                  if cmbCDROM.ItemIndex = (cmbCDROM.Items.Count - 1) then
                  begin
                     if Assigned(cmbCDROM.Items.Objects[cmbCDROM.Items.Count - 1]) then
                        TMyObj(cmbCDROM.Items.Objects[cmbCDROM.Items.Count - 1]).Free();
                     cmbCDROM.Items.Delete(cmbCDROM.Items.Count - 1);
                  end;
                  Obj := TMyObj.Create();
                  Obj.Text := wstrTemp;
                  cmbCDROM.Items.AddObject(WideExtractFileName(wstrTemp), Obj);
                  cmbCDROM.ItemIndex := cmbCDROM.Items.Count - 1;
                  cmbCDROM.Tag := cmbCDROM.ItemIndex;
                  CDDVDType := 1;
                  cmbCDROM.SetFocus;
                  cmbCDROM.OnChange := cmbCDROMChange;
               end
               else
               begin
                  msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                  PostMessage(Handle, WM_USER + 1024, 0, 0);
                  MessageBoxW(Handle,
                     PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotACDOrIso'], 'Not a CD/DVD device or ISO file !')),
                     PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
               end;
            end;
      else
         DragFinish(msg.WParam);
         msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
         PostMessage(Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'JustOneItem'], 'Just one item at a time !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
      end;
   end
   else
      originalcmbCDROMWindowProc(Msg);
end;

procedure TfrmAddEdit.cmbFirstDriveWindowProc(var Msg: TMessage);
var
   Buffer: array[0..MAX_PATH] of AnsiChar;
   strTemp: AnsiString;
   hVolume, hDrive: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   ErrorMode: Word;
begin
   if Msg.Msg = WM_DROPFILES then
   begin
      Application.BringToFront;
      frmMain.Repaint;
      Repaint;
      case DragQueryFile(msg.WParam, $FFFFFFFF, nil, 0) of
         1:
            begin
               DragQueryFile(msg.WParam, 0, @Buffer, SizeOf(Buffer));
               DragFinish(msg.WParam);
               strTemp := AnsiString(Buffer);
               if (Length(strTemp) = 3) and (strTemp[1] in ['A'..'Z']) and (strTemp[2] = ':') and
                  (strTemp[3] = '\') then
               begin
                  ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
                  try
                     case GetDriveType(PAnsiChar(strTemp)) of
                        DRIVE_REMOVABLE, DRIVE_FIXED:
                           begin
                              try
                                 hVolume := CreateFile(PAnsiChar('\\.\' + strTemp[1] + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                              except
                                 hVolume := INVALID_HANDLE_VALUE;
                              end;
                              if hVolume <> INVALID_HANDLE_VALUE then
                              begin
                                 if ListOnlyUSBDrives and (not IsUSBDrive(hVolume)) then
                                 begin
                                    try
                                       CloseHandle(hVolume);
                                    except
                                    end;
                                    msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                    PostMessage(Handle, WM_USER + 1024, 0, 0);
                                    MessageBoxW(Handle,
                                       PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotUSB'], 'This is not a USB drive !')),
                                       PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                    Exit;
                                 end;
                                 dwBytesReturned := 0;
                                 try
                                    if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                                    begin
                                       if sdn.DeviceNumber <> OSDrive then
                                       begin
                                          try
                                             hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(sdn.DeviceNumber)), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                                          except
                                             hDrive := INVALID_HANDLE_VALUE;
                                          end;
                                          if hDrive <> INVALID_HANDLE_VALUE then
                                          begin
                                             try
                                                CloseHandle(hDrive);
                                             except
                                             end;
                                             try
                                                DriveToAdd := sdn.DeviceNumber;
                                                GetDrives(cmbFirstDrive);
                                             finally
                                                DriveToAdd := -1;
                                             end;
                                          end
                                          else
                                          begin
                                             LastError := GetLastError;
                                             msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                             PostMessage(Handle, WM_USER + 1024, 0, 0);
                                             MessageBoxW(Handle,
                                                PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'ErrorAccessDrive'], [WideSysErrorMessage(LastError)], 'Error accessing the drive !'#13#10#13#10'System message: %s')),
                                                PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                          end;
                                       end
                                       else
                                       begin
                                          msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                          PostMessage(Handle, WM_USER + 1024, 0, 0);
                                          MessageBoxW(Handle,
                                             PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'CantUseOSDrive'], 'This is the OS drive, can''t use !')),
                                             PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                       end;
                                    end
                                    else
                                    begin
                                       LastError := GetLastError;
                                       msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                       PostMessage(Handle, WM_USER + 1024, 0, 0);
                                       MessageBoxW(Handle,
                                          PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'ErrorDriveNumber'], [WideSysErrorMessage(LastError)], 'Error getting the drive number !'#13#10#13#10'System message: %s')),
                                          PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                    end;
                                 except
                                    LastError := GetLastError;
                                    msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                    PostMessage(Handle, WM_USER + 1024, 0, 0);
                                    MessageBoxW(Handle,
                                       PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'ErrorAccessVolume'], [WideSysErrorMessage(LastError)], 'Error accessing the volume on drive !'#13#10'System message: %s')),
                                       PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                 end;
                                 try
                                    CloseHandle(hVolume);
                                 except
                                 end;
                              end
                              else
                              begin
                                 LastError := GetLastError;
                                 msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                 PostMessage(Handle, WM_USER + 1024, 0, 0);
                                 MessageBoxW(Handle,
                                    PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'ErrorAccessVolume'], [WideSysErrorMessage(LastError)], 'Error accessing the volume on drive !'#13#10'System message: %s')),
                                    PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                              end;
                           end
                     else
                        msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                        PostMessage(Handle, WM_USER + 1024, 0, 0);
                        MessageBoxW(Handle,
                           PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotADrive'], 'This is not a removable or fixed local drive !')),
                           PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                        Exit;
                     end;
                  finally
                     SetErrorMode(ErrorMode);
                  end;
               end
               else
               begin
                  msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                  PostMessage(Handle, WM_USER + 1024, 0, 0);
                  MessageBoxW(Handle,
                     PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotAVolOrDrive'], 'Not a volume or drive !')),
                     PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
               end;
            end;
      else
         DragFinish(msg.WParam);
         msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
         PostMessage(Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'JustOneItem'], 'Just one item at a time !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
      end;
   end
   else
      originalcmbFirstDriveWindowProc(Msg);
end;

procedure TfrmAddEdit.cmbSecondDriveWindowProc(var Msg: TMessage);
var
   Buffer: array[0..MAX_PATH] of AnsiChar;
   strTemp: AnsiString;
   hVolume, hDrive: THandle;
   dwBytesReturned: DWORD;
   sdn: STORAGE_DEVICE_NUMBER;
   ErrorMode: Word;
begin
   if Msg.Msg = WM_DROPFILES then
   begin
      Application.BringToFront;
      frmMain.Repaint;
      Repaint;
      case DragQueryFile(msg.WParam, $FFFFFFFF, nil, 0) of
         1:
            begin
               DragQueryFile(msg.WParam, 0, @Buffer, SizeOf(Buffer));
               DragFinish(msg.WParam);
               strTemp := AnsiString(Buffer);
               if (Length(strTemp) = 3) and (strTemp[1] in ['A'..'Z']) and (strTemp[2] = ':') and
                  (strTemp[3] = '\') then
               begin
                  ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
                  try
                     case GetDriveType(PAnsiChar(strTemp)) of
                        DRIVE_REMOVABLE, DRIVE_FIXED:
                           begin
                              try
                                 hVolume := CreateFile(PAnsiChar('\\.\' + strTemp[1] + ':'), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                              except
                                 hVolume := INVALID_HANDLE_VALUE;
                              end;
                              if hVolume <> INVALID_HANDLE_VALUE then
                              begin
                                 if ListOnlyUSBDrives and (not IsUSBDrive(hVolume)) then
                                 begin
                                    try
                                       CloseHandle(hVolume);
                                    except
                                    end;
                                    msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                    PostMessage(Handle, WM_USER + 1024, 0, 0);
                                    MessageBoxW(Handle,
                                       PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotUSB'], 'This is not a USB drive !')),
                                       PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                    Exit;
                                 end;
                                 dwBytesReturned := 0;
                                 try
                                    if DeviceIoControl(hVolume, IOCTL_STORAGE_GET_DEVICE_NUMBER, nil, 0, @sdn, sizeof(sdn), dwBytesReturned, nil) then
                                    begin
                                       if sdn.DeviceNumber <> OSDrive then
                                       begin
                                          try
                                             hDrive := CreateFile(PAnsiChar('\\.\PHYSICALDRIVE' + IntToStr(sdn.DeviceNumber)), 0, FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING, 0, 0);
                                          except
                                             hDrive := INVALID_HANDLE_VALUE;
                                          end;
                                          if hDrive <> INVALID_HANDLE_VALUE then
                                          begin
                                             try
                                                CloseHandle(hDrive);
                                             except
                                             end;
                                             try
                                                DriveToAdd := sdn.DeviceNumber;
                                                GetDrives(cmbSecondDrive);
                                             finally
                                                DriveToAdd := -1;
                                             end;
                                          end
                                          else
                                          begin
                                             LastError := GetLastError;
                                             msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                             PostMessage(Handle, WM_USER + 1024, 0, 0);
                                             MessageBoxW(Handle,
                                                PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'ErrorAccessDrive'], [WideSysErrorMessage(LastError)], 'Error accessing the drive !'#13#10#13#10'System message: %s')),
                                                PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                          end;
                                       end
                                       else
                                       begin
                                          msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                          PostMessage(Handle, WM_USER + 1024, 0, 0);
                                          MessageBoxW(Handle,
                                             PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'CantUseOSDrive'], 'This is the OS drive, can''t use !')),
                                             PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                       end;
                                    end
                                    else
                                    begin
                                       LastError := GetLastError;
                                       msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                       PostMessage(Handle, WM_USER + 1024, 0, 0);
                                       MessageBoxW(Handle,
                                          PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'ErrorDriveNumber'], [WideSysErrorMessage(LastError)], 'Error getting the drive number !'#13#10#13#10'System message: %s')),
                                          PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                    end;
                                 except
                                    LastError := GetLastError;
                                    msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                    PostMessage(Handle, WM_USER + 1024, 0, 0);
                                    MessageBoxW(Handle,
                                       PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'ErrorAccessVolume'], [WideSysErrorMessage(LastError)], 'Error accessing the volume on drive !'#13#10#13#10'System message: %s')),
                                       PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                                 end;
                                 try
                                    CloseHandle(hVolume);
                                 except
                                 end;
                              end
                              else
                              begin
                                 LastError := GetLastError;
                                 msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                                 PostMessage(Handle, WM_USER + 1024, 0, 0);
                                 MessageBoxW(Handle,
                                    PWideChar(GetLangTextFormatDef(idxAddEdit, ['Messages', 'ErrorAccessVolume'], [WideSysErrorMessage(LastError)], 'Error accessing the volume on drive !'#13#10#13#10'System message: %s')),
                                    PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                              end;
                           end
                     else
                        msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                        PostMessage(Handle, WM_USER + 1024, 0, 0);
                        MessageBoxW(Handle,
                           PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotADrive'], 'This is not a removable or fixed local drive !')),
                           PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
                        Exit;
                     end;
                  finally
                     SetErrorMode(ErrorMode);
                  end;
               end
               else
               begin
                  msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
                  PostMessage(Handle, WM_USER + 1024, 0, 0);
                  MessageBoxW(Handle,
                     PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'NotAVolOrDrive'], 'Not a volume or drive !')),
                     PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
               end;
            end;
      else
         DragFinish(msg.WParam);
         msgBoxCaption := GetLangTextDef(idxMessagesType, ['Warning'], 'Warning');
         PostMessage(Handle, WM_USER + 1024, 0, 0);
         MessageBoxW(Handle,
            PWideChar(GetLangTextDef(idxAddEdit, ['Messages', 'JustOneItem'], 'Just one item at a time !')),
            PWideChar(msgBoxCaption), MB_OK or MB_ICONWARNING);
      end;
   end
   else
      originalcmbSecondDriveWindowProc(Msg);
end;

function TfrmAddEdit.FindCDROMFromLetter(const CDROMLetter: AnsiChar): AnsiString;
var
   objWMIService: OLEVariant;
   colItems: OLEVariant;
   colItem: OLEVariant;
   oEnum: IEnumvariant;
   iValue: LongWord;
   i, j: Integer;
   isFound: Boolean;
   strTemp: AnsiString;

   function GetWMIObject(const objectName: AnsiString): IDispatch;
   var
      chEaten: Integer;
      BindCtx: IBindCtx;
      Moniker: IMoniker;
   begin
      OleCheck(CreateBindCtx(0, bindCtx));
      OleCheck(MkParseDisplayName(BindCtx, StringToOleStr(objectName), chEaten, Moniker));
      OleCheck(Moniker.BindToObject(BindCtx, nil, IDispatch, Result));
   end;
begin
   Result := '';
   if Succeeded(CoInitialize(nil)) then
      try
         try
            objWMIService := GetWMIObject(Format('winmgmts:\\%s\%s', ['.', 'root\CIMV2']));
            colItems := objWMIService.ExecQuery(Format('SELECT %s FROM %s', ['Drive', 'Win32_CDROMDrive']), 'WQL', 0);
            oEnum := IUnknown(colItems._NewEnum) as IEnumVariant;
            i := 0;
            isFound := False;
            while oEnum.Next(1, colItem, iValue) = 0 do
            begin
               strTemp := colItem.Properties_.Item('Drive', 0);
               if strTemp = (CDROMLetter + ':') then
               begin
                  isFound := True;
                  Break;
               end;
               Inc(i);
            end;
            if not isFound then
               Exit;
            colItems := objWMIService.ExecQuery(Format('SELECT %s FROM %s', ['Caption', 'Win32_CDROMDrive']), 'WQL', 0);
            oEnum := IUnknown(colItems._NewEnum) as IEnumVariant;
            j := 0;
            while oEnum.Next(1, colItem, iValue) = 0 do
            begin
               if i = j then
               begin
                  Result := AnsiString(colItem.Properties_.Item('Caption', 0));
                  Break;
               end;
               Inc(j);
               if j > i then
                  Break;
            end;
         except
         end;
      finally
         CoUninitialize;
      end;
end;

procedure TfrmAddEdit.cmbFirstDriveDrawItem(Control: TWinControl;
   Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
   with Control as TTntComboBox do
   begin
      CBClientWidth := Min(CBClientWidth, Rect.Right - Rect.Left - 1);
      Canvas.FillRect(Rect);
      if Index = 0 then
         Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index])
      else
      begin
         try
            Canvas.TextOut(Rect.Left + 2, Rect.Top, CBFirstDriveName[Index - 1]);
            Canvas.TextOut(Rect.Left + CBClientWidth - Canvas.TextWidth(CBFirstDriveLetters[Index - 1]), Rect.Top, CBFirstDriveLetters[Index - 1]);
            Canvas.TextOut(Rect.Left + CBClientWidth - Canvas.TextWidth(CBFirstDriveSize[Index - 1] + ' ') - CBMaxLetSize, Rect.Top, ' ' + CBFirstDriveSize[Index - 1]);
         except
            Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
         end;
      end;
   end;
end;

procedure TfrmAddEdit.cmbSecondDriveDrawItem(Control: TWinControl;
   Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
   with Control as TTntComboBox do
   begin
      CBClientWidth := Min(CBClientWidth, Rect.Right - Rect.Left - 1);
      Canvas.FillRect(Rect);
      if Index = 0 then
         Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index])
      else
      begin
         try
            Canvas.TextOut(Rect.Left + 2, Rect.Top, CBSecondDriveName[Index - 1]);
            Canvas.TextOut(Rect.Left + CBClientWidth - Canvas.TextWidth(CBSecondDriveLetters[Index - 1]), Rect.Top, CBSecondDriveLetters[Index - 1]);
            Canvas.TextOut(Rect.Left + CBClientWidth - Canvas.TextWidth(CBSecondDriveSize[Index - 1] + ' ') - CBMaxLetSize, Rect.Top, ' ' + CBSecondDriveSize[Index - 1]);
         except
            Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
         end;
      end;
   end;
end;

procedure TfrmAddEdit.cmbCDROMDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
   with Control as TTntComboBox do
   begin
      CBClientWidth := Min(CBClientWidth, Rect.Right - Rect.Left - 1);
      Canvas.FillRect(Rect);
      if (Index = 0) or (Index > nCDROMS) then
         Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index])
      else
      begin
         try
            Canvas.TextOut(Rect.Left + 2, Rect.Top, aCDROMInfo[Index - 1].Name);
            Canvas.TextOut(Rect.Left + CBClientWidth - Canvas.TextWidth(' []' + aCDROMInfo[Index - 1].Letter), Rect.Top, ' [' + aCDROMInfo[Index - 1].Letter + ']');
         except
            Canvas.TextOut(Rect.Left + 2, Rect.Top, Items[Index]);
         end;
      end;
   end;
end;

end.

