unit ProcessViewer;

interface

uses
   Windows, SysUtils, TNTClasses, TLHelp32, Math;

type
   TProcessInfo = record
      WCaption: WideString;
      Handle: Int64;
      WClass: WideString;
   end;

var
   ProcessInfo: array of TProcessInfo;
   FCount, FCapacity: Integer;

function EnumWindowsProc(hWnd: HWND; lParam: LPARAM): Bool; stdcall;
procedure GetProcessList;
function GetFileNameFromHandleW(Handle: Int64): WideString;
function GetFileNameAndThreadFromHandleW(Handle: Int64; var ThreadID: THandle): WideString;

implementation

procedure GetProcessList;
begin
   if Length(ProcessInfo) > 0 then
      SetLength(ProcessInfo, 0);
   SetLength(ProcessInfo, 100);
   FCount := 0;
   FCapacity := 100;
   EnumWindows(@EnumWindowsProc, 0);
   if Length(ProcessInfo) <> FCount then
      SetLength(ProcessInfo, FCount);
end;

function EnumWindowsProc(hWnd: HWND; lParam: LPARAM): Bool;
var
   WCaption, WClass: array[0..255] of WideChar;
begin
   try
      GetWindowTextW(hWnd, WCaption, 255);
      GetClassNameW(hwnd, WClass, 255);
      Inc(FCount);
      if FCount > FCapacity then
      begin
         FCapacity := Ceil(1.1 * FCount);
         SetLength(ProcessInfo, FCapacity);
      end;
      ProcessInfo[FCount - 1].WCaption := WCaption;
      ProcessInfo[FCount - 1].WClass := WClass;
      ProcessInfo[FCount - 1].Handle := hWnd;
   except
   end;
   Result := True;
end;

function GetFileNameFromHandleW(Handle: Int64): WideString;
var
   PID: DWord;
   aSnapShotHandle: THandle;
   ContinueLoop: Boolean;
   aProcessEntry32: TProcessEntry32W;
begin
   GetWindowThreadProcessID(Handle, @PID);
   aSnapShotHandle := CreateToolHelp32SnapShot(TH32CS_SNAPPROCESS, 0);
   aProcessEntry32.dwSize := SizeOf(aProcessEntry32);
   ContinueLoop := Process32FirstW(aSnapShotHandle, aProcessEntry32);
   while Integer(ContinueLoop) <> 0 do
   begin
      if aProcessEntry32.th32ProcessID = PID then
      begin
         Result := WideLowerCase(aProcessEntry32.szExeFile);
         Break;
      end;
      ContinueLoop := Process32NextW(aSnapShotHandle, aProcessEntry32);
   end;
   CloseHandle(aSnapShotHandle);
end;

function GetFileNameAndThreadFromHandleW(Handle: Int64; var ThreadID: THandle): WideString;
var
   PID: DWord;
   aSnapShotHandle: THandle;
   ContinueLoop: Boolean;
   aProcessEntry32: TProcessEntry32W;
begin
   GetWindowThreadProcessID(Handle, @PID);
   aSnapShotHandle := CreateToolHelp32SnapShot(TH32CS_SNAPPROCESS, 0);
   aProcessEntry32.dwSize := SizeOf(aProcessEntry32);
   ContinueLoop := Process32FirstW(aSnapShotHandle, aProcessEntry32);
   while Integer(ContinueLoop) <> 0 do
   begin
      if aProcessEntry32.th32ProcessID = PID then
      begin
         Result := WideLowerCase(aProcessEntry32.szExeFile);
         ThreadID := aProcessEntry32.th32ProcessID;
         Break;
      end;
      ContinueLoop := Process32NextW(aSnapShotHandle, aProcessEntry32);
   end;
   CloseHandle(aSnapShotHandle);
end;

end.

